#!/bin/sh

{{/*
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/}}

set -ex
ETCD_REPLICAS={{ .Values.pod.replicas.etcd }}
PEER_PREFIX_NAME={{- printf "%s-%s" .Release.Name "etcd"  }}
DISCOVERY_DOMAIN={{ tuple "etcd" "discovery" . | include "helm-toolkit.endpoints.hostname_fqdn_endpoint_lookup" }}
PEERS="${PEER_PREFIX_NAME}-0=http://${PEER_PREFIX_NAME}-0.${DISCOVERY_DOMAIN}:2380"
for i in $(seq 1 $(( ETCD_REPLICAS - 1 ))); do
  PEERS="$PEERS,${PEER_PREFIX_NAME}-${i}=http://${PEER_PREFIX_NAME}-${i}.${DISCOVERY_DOMAIN}:2380"
done
ETCD_PEER_PORT=2380
ETCD_CLIENT_PORT={{ tuple "etcd" "internal" "client" . | include "helm-toolkit.endpoints.endpoint_port_lookup" }}
ETCD_PROTOCOL={{ tuple "etcd" "internal" "client" . | include "helm-toolkit.endpoints.keystone_endpoint_scheme_lookup" }}
exec etcd \
  --name ${HOSTNAME} \
  --listen-peer-urls ${ETCD_PROTOCOL}://0.0.0.0:${ETCD_PEER_PORT} \
  --listen-client-urls ${ETCD_PROTOCOL}://0.0.0.0:${ETCD_CLIENT_PORT} \
  --advertise-client-urls ${ETCD_PROTOCOL}://${HOSTNAME}.${DISCOVERY_DOMAIN}:${ETCD_CLIENT_PORT} \
  --initial-advertise-peer-urls ${ETCD_PROTOCOL}://${HOSTNAME}:${ETCD_PEER_PORT} \
  --initial-cluster ${PEERS} \
